# Generated by Django 2.2 on 2022-03-31 07:49

import django.contrib.postgres.fields
import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='ThxEmailBackend',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('status', models.IntegerField(choices=[(0, 'disable'), (1, 'enable')], default=1, null=True, verbose_name='status')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('name', models.CharField(max_length=255, verbose_name='name')),
                ('environment', models.CharField(choices=[('prod', 'production'), ('stag', 'staging'), ('dev', 'develop')], help_text='environment ex: prod, staging, dev etc', max_length=255, verbose_name='environment')),
                ('allowed_addresses', django.contrib.postgres.fields.ArrayField(base_field=models.EmailField(max_length=254), blank=True, default=list, help_text='addresses allowed to receives email from this backend', null=True, size=None, verbose_name='allowed addresses')),
                ('forbidden_addresses', django.contrib.postgres.fields.ArrayField(base_field=models.EmailField(max_length=254), blank=True, default=list, help_text='addresses not allowed to receives email from this backend', null=True, size=None, verbose_name='forbidden addresses')),
                ('allowed_domains', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=255), blank=True, default=list, help_text='domains allowed to receives email from this backend', null=True, size=None, verbose_name='allowed domains')),
                ('forbidden_domains', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=255), blank=True, default=list, help_text='domains not allowed to receives email from this backend', null=True, size=None, verbose_name='forbidden domains')),
                ('default_to_received_addresses', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=255), blank=True, default=list, help_text='fill this field if you want that this addresses will always receives all emails that are sent as TO', null=True, size=None, verbose_name='default to received addresses')),
                ('default_cc_received_addresses', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=255), blank=True, default=list, help_text='fill this field if you want that this addresses will always receives all emails that are sent on CC', null=True, size=None, verbose_name='default cc received addresses')),
                ('default_bcc_received_addresses', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=255), blank=True, default=list, help_text='fill this field if you want that this addresses will always receives all emails that are sent on BCC', null=True, size=None, verbose_name='default bcc received addresses')),
                ('restraint_logic', models.BooleanField(default=True, help_text='if enabled: address or domain that are not included in one of the allowed or default fields will not be included in the recipients. If disabled: every address or domain that are not included in one of the forbidden fields will always be included in the recipients. ', verbose_name='restraint logic')),
                ('enable_loggers', models.BooleanField(default=False, help_text='if enabled logger write info for every single email', verbose_name='enable logger')),
                ('logger', models.CharField(blank=True, default='file', max_length=255, null=True, verbose_name='logger')),
                ('logger_level', models.CharField(blank=True, choices=[('DEBUG', 'DEBUG'), ('INFO', 'INFO'), ('WARNING', 'WARNING'), ('ERROR', 'ERROR'), ('CRITICAL', 'CRITICAL')], default='info', max_length=255, null=True, verbose_name='logger level')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='emailbackend_thxemailbackend_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='emailbackend_thxemailbackend_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
            ],
            options={
                'verbose_name': 'thx email backend',
                'verbose_name_plural': 'thx email backends',
                'ordering': ('ordering', 'environment', 'name', 'status'),
                'permissions': (('list_thxemailbackend', 'Can list thx email backend'), ('detail_thxemailbackend', 'Can detail thx email backend'), ('enable_thxemailbackend', 'Can enable thx email backend'), ('disable_thxemailbackend', 'Can disable thx email backend')),
                'unique_together': {('name', 'environment')},
            },
        ),
    ]
